



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>explain和profiling分析查询SQL时间</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">explain和profiling分析查询SQL时间</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 18:02:29 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>mysql可以通过profiling命令查看到执行查询SQL消耗的时间。</p>
<p>默认情况下，mysql是关闭profiling的，命令：</p>
<div>
<ol><li>select&nbsp;@@profiling;</li></ol>
</div>
<p>+-------------------+</p>
<p>|&nbsp;&nbsp;&nbsp; @@profiling&nbsp;&nbsp;&nbsp; |</p>
<p>+-------------------+</p>
<p>|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 0&nbsp;&nbsp; |</p>
<p>+-------------------+</p>
<p>说明：</p>
<p>0：表示profiling功能是关闭；</p>
<p>1：表示打开的。</p>
<p>可以通过命令打开/关闭profiling功能。</p>
<p>打开命令：</p>
<div>
<ol><li>set&nbsp;profiling=1;</li></ol>
</div>
<p>关闭命令：</p>
<div>
<ol><li>set&nbsp;profiling=0;</li></ol>
</div>
<p>如查询命令：</p>
<p>select * from employee limit 1,10;</p>
<p>可以使用profiling命令查看执行这条SQL消耗的时间：</p>
<div>
<ol><li>show&nbsp;profiles;</li></ol>
</div>
<p>查询结果：</p>
<p>+----------------+-----------------+-------------------------------------------------------------+</p>
<p>| Query_ID&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | Duration&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | Query&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; |</p>
<p>+----------------+-----------------+--------------------------------------------------------------+</p>
<p>|&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; 1&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | 0.00083225&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; | select * from employee limit 1,10&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; |</p>
<p>+----------------+-----------------+--------------------------------------------------------------+</p>
<p>1 row in set ( 0.00 sec)</p>
<p>使用explain来分析是否命中索引</p>
<div>
<ol><li>mysql&gt;&nbsp;explain&nbsp;select&nbsp;*&nbsp;from&nbsp;user&nbsp;where&nbsp;username&nbsp;=&nbsp;'a';</li>
<li>+----+-------------+-------+------+---------------+------------+---------+-------+------+-------------+</li>
<li>|&nbsp;id&nbsp;|&nbsp;select_type&nbsp;|&nbsp;table&nbsp;|&nbsp;type&nbsp;|&nbsp;possible_keys&nbsp;|&nbsp;key&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;key_len&nbsp;|&nbsp;ref&nbsp;&nbsp;&nbsp;|&nbsp;rows&nbsp;|&nbsp;Extra&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|</li>
<li>+----+-------------+-------+------+---------------+------------+---------+-------+------+-------------+</li>
<li>|&nbsp;&nbsp;1&nbsp;|&nbsp;SIMPLE&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;user&nbsp;&nbsp;|&nbsp;ref&nbsp;&nbsp;|&nbsp;user_index&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;user_index&nbsp;|&nbsp;62&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;|&nbsp;const&nbsp;|&nbsp;&nbsp;&nbsp;&nbsp;1&nbsp;|&nbsp;Using&nbsp;where&nbsp;|</li>
<li>+----+-------------+-------+------+---------------+------------+---------+-------+------+-------------+</li>
<li>1&nbsp;row&nbsp;in&nbsp;set&nbsp;(0.00&nbsp;sec)</li></ol>
</div>
<p>可以看出已经命中索引user_index</div>
<div>
<div>
<div>&nbsp;</div>
</div>
</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div>&nbsp;</div>
<div></div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqll7n6q.html">Markdown编辑器入门</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8m2zg2q.html">angularjs与jquery特效slidetoggle结合</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e322zq.html">cent7内核升级4&period;9</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8e32nmq.html">C&plus;&plus;模板&amp;amp&semi;泛型编程</a>
		</li>
						<li><a href="https://www.batexi.com/a/495nzxv9.html">hdu 4967 Handling the Past</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd75mjq.html">野比的示波器案例&lpar;Winfrom用户控件&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952kj69.html">Effective Java 05 Avoid creating unnecessary objects</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvg5jzq.html">winform学习-----理解小概念-20160518</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0j500q.html">anroid打包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okvy0x9.html">C语言基础（不断更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0l23gq.html">Javascript异步请求你能捕获到异常吗？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmp5j19.html">Android 签名&lpar;7&rpar;签名常见问题&comma;debug签名和release签名的区别等</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1dj7j9.html">excel vba 打印设置（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vgkxj8.html">浅析 MySQL Replication（本文转自网络，非本人所写）</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yx1mn8.html">Linux从用户层到内核层系列 - GNU系列之glibc介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meed5pq.html">SqlServer表EXCEL数据复制的另一种方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jzpw7w8.html">（读书笔记）函数参数浅析-JavaScript高级程序设计（第3版）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjwm7y8.html">解读 Vue 之 Reactive</a>
		</li>
						<li><a href="https://www.batexi.com/a/950zrov8.html">python之路第二天 随便记记 今天主要很郁闷</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljw2x19.html">跨站数据请求哪家强&mdash;&mdash;青出于蓝的jsonp</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwn4678.html">Spring &lowbar;day02&lowbar;IoC注解开发入门</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyg0719.html">ESP32搭建4&period;esp32官方程序下载与串口读取</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1rm0x48.html">shiro三连斩之第二斩（SSM）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj03559.html">&lbrack;AutoMapper&rsqb;反射自动注册AutoMapper Profile</a>
			</li>
						<li><a href="https://www.batexi.com/a/9r5dzz7q.html">纯css实现评分</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wxokrq.html">org&period;apache&period;commons&period;lang&period;exception&period;NestableRuntimeException</a>
			</li>
						<li><a href="https://www.batexi.com/a/q25ww0xq.html">Displaylink安卓驱动</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kj11k59.html">makefile笔记7 - makefile函数</a>
			</li>
						<li><a href="https://www.batexi.com/a/9j100wg9.html">&period;net实现扫描二维码登录webqq群抓取qq群信息</a>
			</li>
						<li><a href="https://www.batexi.com/a/qdwejwv9.html">怎么在Mac上安装Tomcat 7&lbrack;转载&rsqb;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
